<?php
// $Id: myhookadmin.inc,v 1.2 2010/08/23 05:00:25 ufku Exp $

/**
 * Generates admin page.
 */
function myhookadmin_admin() {
  $output = drupal_get_form('myhookadmin_admin_form');
  $output .= '<h2>Tips & Links</h2>
  <ul class="tips">
    <li>Example hook_nodeapi() implementation that notifies site admin of new content.<br />
    <code>function myhook_nodeapi(&$node, $op, $a3 = NULL, $a4 = NULL) {<br />
&nbsp; switch ($op) {<br />
&nbsp; &nbsp; case \'insert\':<br />
&nbsp; &nbsp; &nbsp; drupal_mail_send(array(<br />
&nbsp; &nbsp; &nbsp; &nbsp; \'to\' => \'admin@example.com\',<br />
&nbsp; &nbsp; &nbsp; &nbsp; \'subject\' => \'New content\',<br />
&nbsp; &nbsp; &nbsp; &nbsp; \'body\' => \'New content entered at \' . url(\'node/\' . $node->nid, array(\'absolute\' => TRUE)),<br />
&nbsp; &nbsp; &nbsp; &nbsp; \'headers\' => array(\'From\' => variable_get(\'site_mail\', ini_get(\'sendmail_from\'))),<br />
&nbsp; &nbsp; &nbsp; ));<br />
&nbsp; &nbsp; &nbsp; break;<br />
&nbsp; }<br />
}</code>
    </li>
    <li>If your code causes a fatal error or if you want to disable it for a single request, just append <code>?myhook=0</code> to the URL. Ex: ' . url('admin/settings/myhook', array('query' => array('myhook' => '0'), 'absolute' => TRUE)) . '</li>
    <li>You may need to flush caches to make some hooks such as <code>hook_menu()</code> or <code>hook_theme()</code> to take effect.</li>
    <li><a href="http://api.drupal.org/api/group/hooks/6">Drupal core hooks</a></li>
    <li><a href="http://api.lullabot.com/group/views_hooks/6">Views hooks</a></li>
    <li><a href="http://drupal.org/node/342987">CCK hooks</a></li>
    <li><a href="http://api.lullabot.com/group/hooks/6">Various module hooks</a></li>
  </ul>';
  return $output;
}

/**
 * Returns admin form.
 */
function myhookadmin_admin_form(&$form_state) {
  $form = array();
  $form['code'] = array(
    '#title' => 'Custom code',
    '#type' => 'textarea',
    '#default_value' => myhookadmin_myhook_code(),
    '#rows' => 20,
    '#cols' => 60,
    '#description' => 'Define your custom hooks as if they are part of myhook.module. Do not include PHP opening and closing tags.',
  );
  $form['is_inc'] = array(
    '#title' => 'Save the code in a file and include it as a file',
    '#type' => 'checkbox',
    '#default_value' => variable_get('myhookadmin_is_inc', 0),
    '#description' => 'This may save a DB hit and an eval execution on each request as the code will be saved in a file whose path must be defined below.',
  );
  $form['inc_path'] = array(
    '#title' => 'File path to include',
    '#type' => 'textfield',
    '#size' => 60,
    '#default_value' => variable_get('myhookadmin_inc_path', ''),
    '#description' => 'This must be a PHP-writable file path such as ' . file_directory_path() . '/myhook.inc. It will be made readonly automatically after writing.',
  );
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  $form['#validate'][] = 'myhookadmin_admin_validate';
  $form['#submit'][] = 'myhookadmin_admin_submit';
  return $form;
}

/**
 * Validates admin form.
 */
function myhookadmin_admin_validate($form, &$form_state) {
  $is_inc = $form_state['values']['is_inc'];
  $inc_path = $form_state['values']['inc_path'];
  // Check if file is writable
  if ($is_inc) {
    if (empty($inc_path)) {
      return form_set_error('inc_path', 'Please specify a valid file path.');
    }
    if (file_exists($inc_path)) {
      @chmod($inc_path, 0666);
    }
    if (!$fp = fopen($inc_path, 'w')) {
      return form_set_error('inc_path', 'Unable to open the specified file for writing.');
    }
    fwrite($fp, "<?php\n\n" . $form_state['values']['code']);
    fclose($fp);
    @chmod($inc_path, 0444);
  }
}

/**
 * Submits admin form.
 */
function myhookadmin_admin_submit($form, &$form_state) {
  $is_inc = $form_state['values']['is_inc'];
  $inc_path = $form_state['values']['inc_path'];
  $code = $form_state['values']['code'];

  // Save code
  db_query("UPDATE {myhookadmin} SET value = '%s'  WHERE name = 'myhook_code'", $code);

  // Save variables
  variable_set('myhookadmin_is_inc', $is_inc);
  variable_set('myhookadmin_inc_path', $inc_path);

  drupal_set_message('The changes have been saved.');
}